<?php

/**
 * This code was generated by
 * ___ _ _ _ _ _    _ ____    ____ ____ _    ____ ____ _  _ ____ ____ ____ ___ __   __
 *  |  | | | | |    | |  | __ |  | |__| | __ | __ |___ |\ | |___ |__/ |__|  | |  | |__/
 *  |  |_|_| | |___ | |__|    |__| |  | |    |__] |___ | \| |___ |  \ |  |  | |__| |  \
 *
 * Twilio - Flex
 * This is the public Twilio REST API.
 *
 * NOTE: This class is auto generated by OpenAPI Generator.
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Twilio\Rest\FlexApi\V1;

use Twilio\Exceptions\TwilioException;
use Twilio\ListResource;
use Twilio\Options;
use Twilio\Values;
use Twilio\Version;


class AssessmentsList extends ListResource
    {
    /**
     * Construct the AssessmentsList
     *
     * @param Version $version Version that contains the resource
     */
    public function __construct(
        Version $version
    ) {
        parent::__construct($version);

        // Path Solution
        $this->solution = [
        ];

        $this->uri = '/Insights/QM/Assessments';
    }

    /**
     * Create the AssessmentsInstance
     *
     * @param string $categoryId The id of the category
     * @param string $categoryName The name of the category
     * @param string $segmentId Segment Id of the conversation
     * @param string $userName Name of the user assessing conversation
     * @param string $userEmail Email of the user assessing conversation
     * @param string $agentId The id of the Agent
     * @param string $offset The offset of the conversation.
     * @param string $metricId The question Id selected for assessment
     * @param string $metricName The question name of the assessment
     * @param string $answerText The answer text selected by user
     * @param string $answerId The id of the answer selected by user
     * @param string $questionnaireId Questionnaire Id of the associated question
     * @param array|Options $options Optional Arguments
     * @return AssessmentsInstance Created AssessmentsInstance
     * @throws TwilioException When an HTTP error occurs.
     */
    public function create(string $categoryId, string $categoryName, string $segmentId, string $userName, string $userEmail, string $agentId, string $offset, string $metricId, string $metricName, string $answerText, string $answerId, string $questionnaireId, array $options = []): AssessmentsInstance
    {

        $options = new Values($options);

        $data = Values::of([
            'CategoryId' =>
                $categoryId,
            'CategoryName' =>
                $categoryName,
            'SegmentId' =>
                $segmentId,
            'UserName' =>
                $userName,
            'UserEmail' =>
                $userEmail,
            'AgentId' =>
                $agentId,
            'Offset' =>
                $offset,
            'MetricId' =>
                $metricId,
            'MetricName' =>
                $metricName,
            'AnswerText' =>
                $answerText,
            'AnswerId' =>
                $answerId,
            'QuestionnaireId' =>
                $questionnaireId,
        ]);

        $headers = Values::of(['Token' => $options['token']]);

        $payload = $this->version->create('POST', $this->uri, [], $data, $headers);

        return new AssessmentsInstance(
            $this->version,
            $payload
        );
    }


    /**
     * Constructs a AssessmentsContext
     *
     * @param string $assessmentId The id of the assessment to be modified
     */
    public function getContext(
        string $assessmentId
        
    ): AssessmentsContext
    {
        return new AssessmentsContext(
            $this->version,
            $assessmentId
        );
    }

    /**
     * Provide a friendly representation
     *
     * @return string Machine friendly representation
     */
    public function __toString(): string
    {
        return '[Twilio.FlexApi.V1.AssessmentsList]';
    }
}
